;;; d-checkdoc-keywords.el --- abc

;; Copyright 2009, 2010, 2014 Kevin Ryde.

;; Author: Kevin Ryde <user42_kevin@yahoo.com.au>
;; Keywords: abc, def,
;;           ghi

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;; Commentary:
;; 


;;; History:
;; 

;;; Code:

(progn
  (require 'checkdoc)
  (setq checkdoc-comment-style-hooks
	'(checkdoc-keywords-comment)))

(add-to-list 'load-path (expand-file-name ".."))
(autoload 'checkdoc-keywords-comment "checkdoc-keywords")
(add-hook 'checkdoc-comment-style-hooks 'checkdoc-keywords-comment)

(checkdoc-keywords-comment)
(checkdoc-keywords-comment-comma)

(lm-header "Keywords")
(lm-header-multiline "Keywords")

(completing-help-mode 1)

(progn
  (require 'finder)
  (completing-read "Keyword: " finder-known-keywords nil t))

(completing-read "Keyword: " '(("x1" . "yy")
                               ("x2" . "zz")) nil t)


;;-----------------------------------------------------------------------------

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))



;;-----------------------------------------------------------------------------
;; don't need this with lm-keywords accepting multi-line values post-emacs23

(defun checkdoc-keywords-comment-comma ()
  "Check for trailing comma on \"Keyword:\" header."
  (require 'lisp-mnt)
  (require 'checkdoc)
  (save-excursion
    (goto-char (point-min))
    (when (and (re-search-forward (lm-get-header-re "Keywords") nil t)
               (re-search-forward ",[ \t]*$" (line-end-position) t))
      ;; pass COMPLEX since a trailing comma might be a multi-line Keywords
      (if (checkdoc-autofix-ask-replace
           (match-beginning 0) (match-end 0)
           "`Keywords:' shouldn't end with a comma.  Remove? "
           "" ;; replacement
           t) ;; complex
          ;; replaced
          nil
        ;; not replaced
        (checkdoc-create-error "`Keywords:' shouldn't end with a comma.? "
                               (point) (line-end-position)))))
  nil)
(add-hook 'checkdoc-comment-style-hooks 'checkdoc-keywords-comment-comma)









(provide 'd-checkdoc-keywords)

;;; d-checkdoc-keywords.el ends here



