;; Copyright 2009, 2010, 2011, 2014 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------------------------------------------------------------------
(require 'bytecomp)
(byte-compile-sexp '(eval-after-load "foo"
                      '(setq foo '(eval-when-compile (+ 1 2)) )))



;;-----------------------------------------------------------------------------
(find-file "/tmp/sixteen.sqdb")

(progn
  (find-file "/tmp/x.sqdb")
  (goto-char (point-max))
  (insert "fsdjkfs;"))

  (save-buffer)
  (next-error))

(let ((eval-expression-print-length nil)
      (print-length nil))
  (require 'compile)
  (require 'sqlite-dump)
  (switch-to-buffer "x")
  (pp compilation-error-regexp-alist (current-buffer))
  (pp compilation-file-regexp-alist (current-buffer)))


;;-----------------------------------------------------------------------------

(debug-on-entry 'compilation-find-file)


(let ((from (point-min))
      (to (point-max)))
  (let ((copy-buf (get-buffer-create (format " *Format Temp %d*"
					     123))))
    (with-current-buffer copy-buf
      '(set (make-local-variable 'write-region-post-annotation-function)
	   'kill-buffer)
      )
    (copy-to-buffer copy-buf from to)
    (set-buffer copy-buf)
    
    (message "buf %s" (current-buffer))
    (message "file %s" (make-temp-file "foo-"))
    (message "buf %s" (current-buffer))
    
    (switch-to-buffer "*Messages*")))


(let ((b (get-buffer-create " x")))
  (set-buffer b)
)

;;-----------------------------------------------------------------------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------------------------------------------------------------------
