#!/usr/bin/perl -w

# kevspam.pl --- subordinate program for kevspam.el.

# Copyright 2002, 2003 Kevin Ryde
#
# kevspam.pl is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# kevspam.pl is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You can get a copy of the GNU General Public License online at
# http://www.gnu.org/licenses/gpl.txt, or you should have one in the file
# COPYING which comes with GNU Emacs and other GNU programs.  Failing that,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

use strict;
use POSIX;
use Mail::SpamAssassin;
use Mail::SpamAssassin::NoMailAudit;

# put your favourite options here
my $spamtest = Mail::SpamAssassin->new
  ({
    'local_tests_only' => 1,
   });


# change this to "/dev/tty3" or some suitable terminal to get diagnostics.
open DEBUG, ">/dev/null" or die;
autoflush DEBUG 1;
autoflush STDOUT 1;
POSIX::nice(1);

print DEBUG "kevspam.pl running\n";

for (;;) {
  my $header = <STDIN>;
  if ($header !~ /^kevspam begin ([0-9]+)$/) {
    print "ERROR: Bad header: $header\n";
    die;
  }
  my $bytes = 0 + $1;
  print DEBUG "expecting bytes $bytes\n";
  
  my $message;
  my $actual = read STDIN, $message, $bytes;
  print DEBUG "got $actual\n";

  my @message = split /\n/, $message, -1;
  my $mail = Mail::SpamAssassin::NoMailAudit->new(data => \@message);

  my $status = $spamtest->check ($mail);
  if ($status->is_spam ()) {
    print DEBUG "spam\n";
    print "spam\n";
  } else {
    print DEBUG "good\n";
    print "good\n";
  }

  print DEBUG "done\n";
}
